Package icyllis.modernui.transition

# Class Transition

java.lang.Object
icyllis.modernui.transition.Transition

All Implemented Interfaces:
  `Cloneable`

Direct Known Subclasses:
  `TransitionSet`, `Visibility`

public abstract class Transition extends Object implements Cloneable
A Transition holds information about animations that will be run on its targets during a scene change. Subclasses of this abstract class may choreograph several child transitions (`TransitionSet` or they may perform custom animations themselves. Any Transition has two main jobs: (1) capture property values, and (2) play animations based on changes to captured property values. A custom transition knows what property values on View objects are of interest to it, and also knows how to animate changes to those values. For example, the `Fade` transition tracks changes to visibility-related properties and is able to construct and run animations that fade items in or out based on changes to those properties.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static interface`
  `Transition.EpicenterCallback`
  Interface to get the epicenter of Transition.
  `static @interface`
  `Transition.MatchOrder`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `MATCH_ID`
  With `setMatchOrder(int...)`, chooses to match by `View.getId()`.
  `static final int`
  `MATCH_INSTANCE`
  With `setMatchOrder(int...)`, chooses to match by View instance.
  `static final int`
  `MATCH_ITEM_ID`
  With `setMatchOrder(int...)`, chooses to match by the `Adapter` item id.
  `static final int`
  `MATCH_NAME`
  With `setMatchOrder(int...)`, chooses to match by `View.getTransitionName()`.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Transition()`
  Constructs a Transition object with no target objects.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Transition`
  `addListener(TransitionListener listener)`
  Adds a listener to the set of listeners that are sent events through the life of an animation, such as start, repeat, and end.
  `Transition`
  `addTarget(int targetId)`
  Adds the id of a target view that this Transition is interested in animating.
  `Transition`
  `addTarget(View target)`
  Sets the target view instances that this Transition is interested in animating.
  `Transition`
  `addTarget(Class<?> targetType)`
  Adds the Class of a target view that this Transition is interested in animating.
  `Transition`
  `addTarget(String targetName)`
  Adds the transitionName of a target view that this Transition is interested in animating.
  `protected void`
  `animate(Animator animator)`
  This is a utility method used by subclasses to handle standard parts of setting up and running an Animator: it sets the `duration` and the `startDelay`, starts the animation, and, when the animator ends, calls `end()`.
  `void`
  `cancel()`
  This method cancels a transition that is currently running.
  `abstract void`
  `captureEndValues(TransitionValues transitionValues)`
  Captures the values in the end scene for the properties that this transition monitors.
  `abstract void`
  `captureStartValues(TransitionValues transitionValues)`
  Captures the values in the start scene for the properties that this transition monitors.
  `Transition`
  `clone()`
  `Animator`
  `createAnimator(ViewGroup sceneRoot, TransitionValues startValues, TransitionValues endValues)`
  This method creates an animation that will be run for this transition given the information in the startValues and endValues structures captured earlier for the start and end scenes.
  `protected void`
  `createAnimators(ViewGroup sceneRoot, icyllis.modernui.transition.Transition.TransitionValuesMaps startValues, icyllis.modernui.transition.Transition.TransitionValuesMaps endValues, ArrayList<TransitionValues> startValuesList, ArrayList<TransitionValues> endValuesList)`
  This method, essentially a wrapper around all calls to createAnimator for all possible target views, is called with the entire set of start/end values.
  `protected void`
  `end()`
  This method is called automatically by the Transition and TransitionSet classes when a transition finishes, either because a transition did nothing (returned a null Animator from `createAnimator(ViewGroup, TransitionValues, TransitionValues)`) or because the transition returned a valid Animator and end() was called in the onAnimationEnd() callback of the AnimatorListener.
  `Transition`
  `excludeChildren(int targetId, boolean exclude)`
  Whether to add the children of the given id to the list of targets to exclude from this transition.
  `Transition`
  `excludeChildren(View target, boolean exclude)`
  Whether to add the children of given target to the list of target children to exclude from this transition.
  `Transition`
  `excludeChildren(Class<?> type, boolean exclude)`
  Whether to add the given type to the list of types whose children should be excluded from this transition.
  `Transition`
  `excludeTarget(int targetId, boolean exclude)`
  Whether to add the given id to the list of target ids to exclude from this transition.
  `Transition`
  `excludeTarget(View target, boolean exclude)`
  Whether to add the given target to the list of targets to exclude from this transition.
  `Transition`
  `excludeTarget(Class<?> type, boolean exclude)`
  Whether to add the given type to the list of types to exclude from this transition.
  `Transition`
  `excludeTarget(String targetName, boolean exclude)`
  Whether to add the given transitionName to the list of target transitionNames to exclude from this transition.
  `long`
  `getDuration()`
  Returns the duration set on this transition.
  `Rect`
  `getEpicenter()`
  Returns the epicenter as specified by the `Transition.EpicenterCallback` or null if no callback exists.
  `Transition.EpicenterCallback`
  `getEpicenterCallback()`
  Returns the callback used to find the epicenter of the Transition.
  `TimeInterpolator`
  `getInterpolator()`
  Returns the interpolator set on this transition.
  `String`
  `getName()`
  Returns the name of this Transition.
  `TransitionPropagation`
  `getPropagation()`
  Returns the `TransitionPropagation` used to calculate Animator start delays.
  `long`
  `getStartDelay()`
  Returns the startDelay set on this transition.
  `it.unimi.dsi.fastutil.ints.IntList`
  `getTargetIds()`
  Returns the array of target IDs that this transition limits itself to tracking and animating.
  `List<String>`
  `getTargetNames()`
  Returns the list of target transitionNames that this transition limits itself to tracking and animating.
  `List<View>`
  `getTargets()`
  Returns the array of target views that this transition limits itself to tracking and animating.
  `List<Class<?>>`
  `getTargetTypes()`
  Returns the list of target transitionNames that this transition limits itself to tracking and animating.
  `String[]`
  `getTransitionProperties()`
  Returns the set of property names used stored in the `TransitionValues` object passed into `captureStartValues(TransitionValues)` that this transition cares about for the purposes of canceling overlapping animations.
  `TransitionValues`
  `getTransitionValues(View view, boolean start)`
  This method can be called by transitions to get the TransitionValues for any particular view during the transition-playing process.
  `boolean`
  `isTransitionRequired(TransitionValues startValues, TransitionValues endValues)`
  Returns whether the transition should create an Animator, based on the values captured during `captureStartValues(TransitionValues)` and `captureEndValues(TransitionValues)`.
  `void`
  `pause(View sceneRoot)`
  Pauses this transition, sending out calls to `TransitionListener.onTransitionPause(Transition)` to all listeners and pausing all running animators started by this transition.
  `Transition`
  `removeListener(TransitionListener listener)`
  Removes a listener from the set listening to this animation.
  `Transition`
  `removeTarget(int targetId)`
  Removes the given targetId from the list of ids that this Transition is interested in animating.
  `Transition`
  `removeTarget(View target)`
  Removes the given target from the list of targets that this Transition is interested in animating.
  `Transition`
  `removeTarget(Class<?> target)`
  Removes the given target from the list of targets that this Transition is interested in animating.
  `Transition`
  `removeTarget(String targetName)`
  Removes the given targetName from the list of transitionNames that this Transition is interested in animating.
  `protected void`
  `resume(View sceneRoot)`
  Resumes this transition, sending out calls to `TransitionListener.onTransitionPause(Transition)` to all listeners and pausing all running animators started by this transition.
  `protected void`
  `runAnimators()`
  This is called internally once all animations have been set up by the transition hierarchy.
  `Transition`
  `setDuration(long duration)`
  Sets the duration of this transition.
  `void`
  `setEpicenterCallback(Transition.EpicenterCallback epicenterCallback)`
  Sets the callback to use to find the epicenter of a Transition.
  `Transition`
  `setInterpolator(TimeInterpolator interpolator)`
  Sets the interpolator of this transition.
  `void`
  `setMatchOrder(int... matches)`
  Sets the order in which Transition matches View start and end values.
  `void`
  `setPropagation(TransitionPropagation transitionPropagation)`
  Sets the method for determining Animator start delays.
  `Transition`
  `setStartDelay(long startDelay)`
  Sets the startDelay of this transition.
  `protected void`
  `start()`
  This method is called automatically by the transition and TransitionSet classes prior to a Transition subclass starting; subclasses should not need to call it directly.
  `String`
  `toString()`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### MATCH_INSTANCE

    public static final int MATCH_INSTANCE
    With `setMatchOrder(int...)`, chooses to match by View instance.
    See Also:
      - Constant Field Values

  - ### MATCH_NAME

    public static final int MATCH_NAME
    With `setMatchOrder(int...)`, chooses to match by `View.getTransitionName()`. Null names will not be matched.
    See Also:
      - Constant Field Values

  - ### MATCH_ID

    public static final int MATCH_ID
    With `setMatchOrder(int...)`, chooses to match by `View.getId()`. Negative IDs will not be matched.
    See Also:
      - Constant Field Values

  - ### MATCH_ITEM_ID

    public static final int MATCH_ITEM_ID
    With `setMatchOrder(int...)`, chooses to match by the `Adapter` item id. When `Adapter.hasStableIds()` returns false, no match will be made for items.
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### Transition

    public Transition()
    Constructs a Transition object with no target objects. A transition with no targets defaults to running on all target objects in the scene hierarchy (if the transition is not contained in a TransitionSet), or all target objects passed down from its parent (if it is in a TransitionSet).

- ## Method Details

  - ### setDuration

    @Nonnull public Transition setDuration(long duration)
    Sets the duration of this transition. By default, there is no duration (indicated by a negative number), which means that the Animator created by the transition will have its own specified duration. If the duration of a Transition is set, that duration will override the Animator duration.
    Parameters:
      `duration` - The length of the animation, in milliseconds.
    Returns:
      This transition object.

  - ### getDuration

    public long getDuration()
    Returns the duration set on this transition. If no duration has been set, the returned value will be negative, indicating that resulting animators will retain their own durations.
    Returns:
      The duration set on this transition, in milliseconds, if one has been set, otherwise returns a negative number.

  - ### setStartDelay

    @Nonnull public Transition setStartDelay(long startDelay)
    Sets the startDelay of this transition. By default, there is no delay (indicated by a negative number), which means that the Animator created by the transition will have its own specified startDelay. If the delay of a Transition is set, that delay will override the Animator delay.
    Parameters:
      `startDelay` - The length of the delay, in milliseconds.
    Returns:
      This transition object.

  - ### getStartDelay

    public long getStartDelay()
    Returns the startDelay set on this transition. If no startDelay has been set, the returned value will be negative, indicating that resulting animators will retain their own startDelays.
    Returns:
      The startDelay set on this transition, in milliseconds, if one has been set, otherwise returns a negative number.

  - ### setInterpolator

    @Nonnull public Transition setInterpolator(@Nullable TimeInterpolator interpolator)
    Sets the interpolator of this transition. By default, the interpolator is null, which means that the Animator created by the transition will have its own specified interpolator. If the interpolator of a Transition is set, that interpolator will override the Animator interpolator.
    Parameters:
      `interpolator` - The time interpolator used by the transition
    Returns:
      This transition object.

  - ### getInterpolator

    @Nullable public TimeInterpolator getInterpolator()
    Returns the interpolator set on this transition. If no interpolator has been set, the returned value will be null, indicating that resulting animators will retain their own interpolators.
    Returns:
      The interpolator set on this transition, if one has been set, otherwise returns null.

  - ### getTransitionProperties

    @Nullable public String[] getTransitionProperties()
    Returns the set of property names used stored in the `TransitionValues` object passed into `captureStartValues(TransitionValues)` that this transition cares about for the purposes of canceling overlapping animations. When any transition is started on a given scene root, all transitions currently running on that same scene root are checked to see whether the properties on which they based their animations agree with the end values of the same properties in the new transition. If the end values are not equal, then the old animation is canceled since the new transition will start a new animation to these new values. If the values are equal, the old animation is allowed to continue and no new animation is started for that transition.

    A transition does not need to override this method. However, not doing so will mean that the cancellation logic outlined in the previous paragraph will be skipped for that transition, possibly leading to artifacts as old transitions and new transitions on the same targets run in parallel, animating views toward potentially different end values.

    Returns:
      An array of property names as described in the class documentation for `TransitionValues`. The default implementation returns `null`.

  - ### createAnimator

    @Nullable public Animator createAnimator(@Nonnull ViewGroup sceneRoot, @Nullable TransitionValues startValues, @Nullable TransitionValues endValues)
    This method creates an animation that will be run for this transition given the information in the startValues and endValues structures captured earlier for the start and end scenes. Subclasses of Transition should override this method. The method should only be called by the transition system; it is not intended to be called from external classes.

    This method is called by the transition's parent (all the way up to the topmost Transition in the hierarchy) with the sceneRoot and start/end values that the transition may need to set up initial target values and construct an appropriate animation. For example, if an overall Transition is a `TransitionSet` consisting of several child transitions in sequence, then some of the child transitions may want to set initial values on target views prior to the overall Transition commencing, to put them in an appropriate state for the delay between that start and the child Transition start time. For example, a transition that fades an item in may wish to set the starting alpha value to 0, to avoid it blinking in prior to the transition actually starting the animation. This is necessary because the scene change that triggers the Transition will automatically set the end-scene on all target views, so a Transition that wants to animate from a different value should set that value prior to returning from this method.

    Additionally, a Transition can perform logic to determine whether the transition needs to run on the given target and start/end values. For example, a transition that resizes objects on the screen may wish to avoid running for views which are not present in either the start or end scenes.

    If there is an animator created and returned from this method, the transition mechanism will apply any applicable duration, startDelay, and interpolator to that animation and start it. A return value of `null` indicates that no animation should run. The default implementation returns null.

    The method is called for every applicable target object, which is stored in the `TransitionValues.view` field.

    Parameters:
      `sceneRoot` - The root of the transition hierarchy.
      `startValues` - The values for a specific target in the start scene.
      `endValues` - The values for the target in the end scene.
    Returns:
      An Animator to be started at the appropriate time in the overall transition for this scene change. A null value means no animation should be run.

  - ### setMatchOrder

    public void setMatchOrder(int... matches)
    Sets the order in which Transition matches View start and end values.

    The default behavior is to match first by `View.getTransitionName()`, then by View instance, then by `View.getId()` and finally by its item ID if it is in a direct child of ListView. The caller can choose to have only some or all of the values of `MATCH_INSTANCE`, `MATCH_NAME`, `MATCH_ITEM_ID`, and `MATCH_ID`. Only the match algorithms supplied will be used to determine whether Views are the the same in both the start and end Scene. Views that do not match will be considered as entering or leaving the Scene.

    Parameters:
      `matches` - A list of zero or more of `MATCH_INSTANCE`, `MATCH_NAME`, `MATCH_ITEM_ID`, and `MATCH_ID`. If none are provided, then the default match order will be set.

  - ### createAnimators

    protected void createAnimators(@Nonnull ViewGroup sceneRoot, @Nonnull icyllis.modernui.transition.Transition.TransitionValuesMaps startValues, @Nonnull icyllis.modernui.transition.Transition.TransitionValuesMaps endValues, @Nonnull ArrayList<TransitionValues> startValuesList, @Nonnull ArrayList<TransitionValues> endValuesList)
    This method, essentially a wrapper around all calls to createAnimator for all possible target views, is called with the entire set of start/end values. The implementation in Transition iterates through these lists and calls `createAnimator(ViewGroup, TransitionValues, TransitionValues)` with each set of start/end values on this transition. The TransitionSet subclass overrides this method and delegates it to each of its children in succession.

  - ### runAnimators

    protected void runAnimators()
    This is called internally once all animations have been set up by the transition hierarchy.

  - ### captureStartValues

    public abstract void captureStartValues(@Nonnull TransitionValues transitionValues)
    Captures the values in the start scene for the properties that this transition monitors. These values are then passed as the startValues structure in a later call to `createAnimator(ViewGroup, TransitionValues, TransitionValues)`. The main concern for an implementation is what the properties are that the transition cares about and what the values are for all of those properties. The start and end values will be compared later during the `createAnimator(ViewGroup, TransitionValues, TransitionValues)` method to determine what, if any, animations, should be run.

    Subclasses must implement this method. The method should only be called by the transition system; it is not intended to be called from external classes.

    Parameters:
      `transitionValues` - The holder for any values that the Transition wishes to store. Values are stored in the `values` field of this TransitionValues object and are keyed from a String value. For example, to store a view's rotation value, a transition might call `transitionValues.values.put("appname:transitionname:rotation", view.getRotation())`. The target view will already be stored in the transitionValues structure when this method is called.
    See Also:
      - `captureEndValues(TransitionValues)`
      - `createAnimator(ViewGroup, TransitionValues, TransitionValues)`

  - ### captureEndValues

    public abstract void captureEndValues(@Nonnull TransitionValues transitionValues)
    Captures the values in the end scene for the properties that this transition monitors. These values are then passed as the endValues structure in a later call to `createAnimator(ViewGroup, TransitionValues, TransitionValues)`. The main concern for an implementation is what the properties are that the transition cares about and what the values are for all of those properties. The start and end values will be compared later during the `createAnimator(ViewGroup, TransitionValues, TransitionValues)` method to determine what, if any, animations, should be run.

    Subclasses must implement this method. The method should only be called by the transition system; it is not intended to be called from external classes.

    Parameters:
      `transitionValues` - The holder for any values that the Transition wishes to store. Values are stored in the `values` field of this TransitionValues object and are keyed from a String value. For example, to store a view's rotation value, a transition might call `transitionValues.values.put("appname:transitionname:rotation", view.getRotation())`. The target view will already be stored in the transitionValues structure when this method is called.
    See Also:
      - `captureStartValues(TransitionValues)`
      - `createAnimator(ViewGroup, TransitionValues, TransitionValues)`

  - ### addTarget

    @Nonnull public Transition addTarget(@Nonnull View target)
    Sets the target view instances that this Transition is interested in animating. By default, there are no targets, and a Transition will listen for changes on every view in the hierarchy below the sceneRoot of the Scene being transitioned into. Setting targets constrains the Transition to only listen for, and act on, these views. All other views will be ignored.

    The target list is like the `targetId` list except this list specifies the actual View instances, not the ids of the views. This is an important distinction when scene changes involve view hierarchies which have been inflated separately; different views may share the same id but not actually be the same instance. If the transition should treat those views as the same, then `addTarget(int)` should be used instead of this method. If, on the other hand, scene changes involve changes all within the same view hierarchy, among views which do not necessarily have ids set on them, then the target list of views may be more convenient.

    Parameters:
      `target` - A View on which the Transition will act, must be non-null.
    Returns:
      The Transition to which the target is added. Returning the same object makes it easier to chain calls during construction, such as `transitionSet.addTransitions(new Fade()).addTarget(someView);`
    See Also:
      - `addTarget(int)`

  - ### addTarget

    @Nonnull public Transition addTarget(int targetId)
    Adds the id of a target view that this Transition is interested in animating. By default, there are no targetIds, and a Transition will listen for changes on every view in the hierarchy below the sceneRoot of the Scene being transitioned into. Setting targetIds constrains the Transition to only listen for, and act on, views with these IDs. Views with different IDs, or no IDs whatsoever, will be ignored.

    Note that using ids to specify targets implies that ids should be unique within the view hierarchy underneath the scene root.

    Parameters:
      `targetId` - The id of a target view, must be a positive number.
    Returns:
      The Transition to which the targetId is added. Returning the same object makes it easier to chain calls during construction, such as `transitionSet.addTransitions(new Fade()).addTarget(someId);`
    See Also:
      - `View.getId()`

  - ### addTarget

    @Nonnull public Transition addTarget(@Nonnull String targetName)
    Adds the transitionName of a target view that this Transition is interested in animating. By default, there are no targetNames, and a Transition will listen for changes on every view in the hierarchy below the sceneRoot of the Scene being transitioned into. Setting targetNames constrains the Transition to only listen for, and act on, views with these transitionNames. Views with different transitionNames, or no transitionName whatsoever, will be ignored.

    Note that transitionNames should be unique within the view hierarchy.

    Parameters:
      `targetName` - The transitionName of a target view, must be non-null.
    Returns:
      The Transition to which the target transitionName is added. Returning the same object makes it easier to chain calls during construction, such as `transitionSet.addTransitions(new Fade()).addTarget(someName);`
    See Also:
      - `View.getTransitionName()`

  - ### addTarget

    @Nonnull public Transition addTarget(@Nonnull Class<?> targetType)
    Adds the Class of a target view that this Transition is interested in animating. By default, there are no targetTypes, and a Transition will listen for changes on every view in the hierarchy below the sceneRoot of the Scene being transitioned into. Setting targetTypes constrains the Transition to only listen for, and act on, views with these classes. Views with different classes will be ignored.

    Note that any View that can be cast to targetType will be included, so if targetType is `View.class`, all Views will be included.

    Parameters:
      `targetType` - The type to include when running this transition.
    Returns:
      The Transition to which the target class was added. Returning the same object makes it easier to chain calls during construction, such as `transitionSet.addTransitions(new Fade()).addTarget(ImageView.class);`
    See Also:
      - `addTarget(int)`
      - `addTarget(View)`
      - `excludeTarget(Class, boolean)`
      - `excludeChildren(Class, boolean)`

  - ### removeTarget

    @Nonnull public Transition removeTarget(@Nonnull View target)
    Removes the given target from the list of targets that this Transition is interested in animating.
    Parameters:
      `target` - The target view, must be non-null.
    Returns:
      Transition The Transition from which the target is removed. Returning the same object makes it easier to chain calls during construction, such as `transitionSet.addTransitions(new Fade()).removeTarget(someView);`

  - ### removeTarget

    @Nonnull public Transition removeTarget(int targetId)
    Removes the given targetId from the list of ids that this Transition is interested in animating.
    Parameters:
      `targetId` - The id of a target view, must be a positive number.
    Returns:
      The Transition from which the targetId is removed. Returning the same object makes it easier to chain calls during construction, such as `transitionSet.addTransitions(new Fade()).removeTargetId(someId);`

  - ### removeTarget

    @Nonnull public Transition removeTarget(@Nonnull String targetName)
    Removes the given targetName from the list of transitionNames that this Transition is interested in animating.
    Parameters:
      `targetName` - The transitionName of a target view, must not be null.
    Returns:
      The Transition from which the targetName is removed. Returning the same object makes it easier to chain calls during construction, such as `transitionSet.addTransitions(new Fade()).removeTargetName(someName);`

  - ### removeTarget

    @Nonnull public Transition removeTarget(@Nonnull Class<?> target)
    Removes the given target from the list of targets that this Transition is interested in animating.
    Parameters:
      `target` - The type of the target view, must be non-null.
    Returns:
      Transition The Transition from which the target is removed. Returning the same object makes it easier to chain calls during construction, such as `transitionSet.addTransitions(new Fade()).removeTarget(someType);`

  - ### excludeTarget

    @Nonnull public Transition excludeTarget(@Nonnull View target, boolean exclude)
    Whether to add the given target to the list of targets to exclude from this transition. The `exclude` parameter specifies whether the target should be added to or removed from the excluded list.

    Excluding targets is a general mechanism for allowing transitions to run on a view hierarchy while skipping target views that should not be part of the transition. For example, you may want to avoid animating children of a specific ListView or Spinner. Views can be excluded either by their id, or by their instance reference, or by the Class of that view (eg, `Spinner`).

    Parameters:
      `target` - The target to ignore when running this transition.
      `exclude` - Whether to add the target to or remove the target from the current list of excluded targets.
    Returns:
      This transition object.
    See Also:
      - `excludeChildren(View, boolean)`
      - `excludeTarget(int, boolean)`
      - `excludeTarget(Class, boolean)`

  - ### excludeTarget

    @Nonnull public Transition excludeTarget(int targetId, boolean exclude)
    Whether to add the given id to the list of target ids to exclude from this transition. The `exclude` parameter specifies whether the target should be added to or removed from the excluded list.

    Excluding targets is a general mechanism for allowing transitions to run on a view hierarchy while skipping target views that should not be part of the transition. For example, you may want to avoid animating children of a specific ListView or Spinner. Views can be excluded either by their id, or by their instance reference, or by the Class of that view (eg, `Spinner`).

    Parameters:
      `targetId` - The id of a target to ignore when running this transition.
      `exclude` - Whether to add the target to or remove the target from the current list of excluded targets.
    Returns:
      This transition object.
    See Also:
      - `excludeChildren(int, boolean)`
      - `excludeTarget(View, boolean)`
      - `excludeTarget(Class, boolean)`

  - ### excludeTarget

    @Nonnull public Transition excludeTarget(@Nonnull String targetName, boolean exclude)
    Whether to add the given transitionName to the list of target transitionNames to exclude from this transition. The `exclude` parameter specifies whether the target should be added to or removed from the excluded list.

    Excluding targets is a general mechanism for allowing transitions to run on a view hierarchy while skipping target views that should not be part of the transition. For example, you may want to avoid animating children of a specific ListView or Spinner. Views can be excluded by their id, their instance reference, their transitionName, or by the Class of that view (eg, `Spinner`).

    Parameters:
      `targetName` - The name of a target to ignore when running this transition.
      `exclude` - Whether to add the target to or remove the target from the current list of excluded targets.
    Returns:
      This transition object.
    See Also:
      - `excludeTarget(View, boolean)`
      - `excludeTarget(int, boolean)`
      - `excludeTarget(Class, boolean)`

  - ### excludeChildren

    @Nonnull public Transition excludeChildren(@Nonnull View target, boolean exclude)
    Whether to add the children of given target to the list of target children to exclude from this transition. The `exclude` parameter specifies whether the target should be added to or removed from the excluded list.

    Excluding targets is a general mechanism for allowing transitions to run on a view hierarchy while skipping target views that should not be part of the transition. For example, you may want to avoid animating children of a specific ListView or Spinner. Views can be excluded either by their id, or by their instance reference, or by the Class of that view (eg, `Spinner`).

    Parameters:
      `target` - The target to ignore when running this transition.
      `exclude` - Whether to add the target to or remove the target from the current list of excluded targets.
    Returns:
      This transition object.
    See Also:
      - `excludeTarget(View, boolean)`
      - `excludeChildren(int, boolean)`
      - `excludeChildren(Class, boolean)`

  - ### excludeChildren

    @Nonnull public Transition excludeChildren(int targetId, boolean exclude)
    Whether to add the children of the given id to the list of targets to exclude from this transition. The `exclude` parameter specifies whether the children of the target should be added to or removed from the excluded list. Excluding children in this way provides a simple mechanism for excluding all children of specific targets, rather than individually excluding each child individually.

    Excluding targets is a general mechanism for allowing transitions to run on a view hierarchy while skipping target views that should not be part of the transition. For example, you may want to avoid animating children of a specific ListView or Spinner. Views can be excluded either by their id, or by their instance reference, or by the Class of that view (eg, `Spinner`).

    Parameters:
      `targetId` - The id of a target whose children should be ignored when running this transition.
      `exclude` - Whether to add the target to or remove the target from the current list of excluded-child targets.
    Returns:
      This transition object.
    See Also:
      - `excludeTarget(int, boolean)`
      - `excludeChildren(View, boolean)`
      - `excludeChildren(Class, boolean)`

  - ### excludeTarget

    @Nonnull public Transition excludeTarget(@Nonnull Class<?> type, boolean exclude)
    Whether to add the given type to the list of types to exclude from this transition. The `exclude` parameter specifies whether the target type should be added to or removed from the excluded list.

    Excluding targets is a general mechanism for allowing transitions to run on a view hierarchy while skipping target views that should not be part of the transition. For example, you may want to avoid animating children of a specific ListView or Spinner. Views can be excluded either by their id, or by their instance reference, or by the Class of that view (eg, `Spinner`).

    Parameters:
      `type` - The type to ignore when running this transition.
      `exclude` - Whether to add the target type to or remove it from the current list of excluded target types.
    Returns:
      This transition object.
    See Also:
      - `excludeChildren(Class, boolean)`
      - `excludeTarget(int, boolean)`
      - `excludeTarget(View, boolean)`

  - ### excludeChildren

    @Nonnull public Transition excludeChildren(@Nonnull Class<?> type, boolean exclude)
    Whether to add the given type to the list of types whose children should be excluded from this transition. The `exclude` parameter specifies whether the target type should be added to or removed from the excluded list.

    Excluding targets is a general mechanism for allowing transitions to run on a view hierarchy while skipping target views that should not be part of the transition. For example, you may want to avoid animating children of a specific ListView or Spinner. Views can be excluded either by their id, or by their instance reference, or by the Class of that view (eg, `Spinner`).

    Parameters:
      `type` - The type to ignore when running this transition.
      `exclude` - Whether to add the target type to or remove it from the current list of excluded target types.
    Returns:
      This transition object.
    See Also:
      - `excludeTarget(Class, boolean)`
      - `excludeChildren(int, boolean)`
      - `excludeChildren(View, boolean)`

  - ### getTargetIds

    @Nonnull public it.unimi.dsi.fastutil.ints.IntList getTargetIds()
    Returns the array of target IDs that this transition limits itself to tracking and animating. If the array is null for both this method and `getTargets()`, then this transition is not limited to specific views, and will handle changes to any views in the hierarchy of a scene change.
    Returns:
      the list of target IDs

  - ### getTargets

    @Nonnull public List<View> getTargets()
    Returns the array of target views that this transition limits itself to tracking and animating. If the array is null for both this method and `getTargetIds()`, then this transition is not limited to specific views, and will handle changes to any views in the hierarchy of a scene change.
    Returns:
      the list of target views

  - ### getTargetNames

    @Nullable public List<String> getTargetNames()
    Returns the list of target transitionNames that this transition limits itself to tracking and animating. If the list is null or empty for `getTargetIds()`, `getTargets()`, `getTargetTypes()`, and this method then this transition is not limited to specific views, and will handle changes to any views in the hierarchy of a scene change.
    Returns:
      the list of target transitionNames

  - ### getTargetTypes

    @Nullable public List<Class<?>> getTargetTypes()
    Returns the list of target transitionNames that this transition limits itself to tracking and animating. If the list is null or empty for `getTargetIds()`, `getTargets()`, `getTargetNames()`, and this method then this transition is not limited to specific views, and will handle changes to any views in the hierarchy of a scene change.
    Returns:
      the list of target Types

  - ### getTransitionValues

    @Nullable public TransitionValues getTransitionValues(@Nonnull View view, boolean start)
    This method can be called by transitions to get the TransitionValues for any particular view during the transition-playing process. This might be necessary, for example, to query the before/after state of related views for a given transition.

  - ### pause

    public void pause(View sceneRoot)
    Pauses this transition, sending out calls to `TransitionListener.onTransitionPause(Transition)` to all listeners and pausing all running animators started by this transition.

  - ### resume

    protected void resume(@Nonnull View sceneRoot)
    Resumes this transition, sending out calls to `TransitionListener.onTransitionPause(Transition)` to all listeners and pausing all running animators started by this transition.

  - ### isTransitionRequired

    public boolean isTransitionRequired(@Nullable TransitionValues startValues, @Nullable TransitionValues endValues)
    Returns whether the transition should create an Animator, based on the values captured during `captureStartValues(TransitionValues)` and `captureEndValues(TransitionValues)`. The default implementation compares the property values returned from `getTransitionProperties()`, or all property values if `getTransitionProperties()` returns null. Subclasses may override this method to provide logic more specific to the transition implementation.
    Parameters:
      `startValues` - the values from captureStartValues, This may be `null` if the View did not exist in the start state.
      `endValues` - the values from captureEndValues. This may be `null` if the View did not exist in the end state.

  - ### animate

    protected void animate(@Nullable Animator animator)
    This is a utility method used by subclasses to handle standard parts of setting up and running an Animator: it sets the `duration` and the `startDelay`, starts the animation, and, when the animator ends, calls `end()`.
    Parameters:
      `animator` - The Animator to be run during this transition.

  - ### start

    protected void start()
    This method is called automatically by the transition and TransitionSet classes prior to a Transition subclass starting; subclasses should not need to call it directly.

  - ### end

    protected void end()
    This method is called automatically by the Transition and TransitionSet classes when a transition finishes, either because a transition did nothing (returned a null Animator from `createAnimator(ViewGroup, TransitionValues, TransitionValues)`) or because the transition returned a valid Animator and end() was called in the onAnimationEnd() callback of the AnimatorListener.

  - ### cancel

    public void cancel()
    This method cancels a transition that is currently running.

  - ### addListener

    @Nonnull public Transition addListener(@Nonnull TransitionListener listener)
    Adds a listener to the set of listeners that are sent events through the life of an animation, such as start, repeat, and end.
    Parameters:
      `listener` - the listener to be added to the current set of listeners for this animation.
    Returns:
      This transition object.

  - ### removeListener

    @Nonnull public Transition removeListener(@Nonnull TransitionListener listener)
    Removes a listener from the set listening to this animation.
    Parameters:
      `listener` - the listener to be removed from the current set of listeners for this transition.
    Returns:
      This transition object.

  - ### setEpicenterCallback

    public void setEpicenterCallback(@Nullable Transition.EpicenterCallback epicenterCallback)
    Sets the callback to use to find the epicenter of a Transition. A null value indicates that there is no epicenter in the Transition and onGetEpicenter() will return null. Transitions like `Explode` use a point or Rect to orient the direction of travel. This is called the epicenter of the Transition and is typically centered on a touched View. The `Transition.EpicenterCallback` allows a Transition to dynamically retrieve the epicenter during a Transition.
    Parameters:
      `epicenterCallback` - The callback to use to find the epicenter of the Transition.

  - ### getEpicenterCallback

    @Nullable public Transition.EpicenterCallback getEpicenterCallback()
    Returns the callback used to find the epicenter of the Transition. Transitions like `Explode` use a point or Rect to orient the direction of travel. This is called the epicenter of the Transition and is typically centered on a touched View. The `Transition.EpicenterCallback` allows a Transition to dynamically retrieve the epicenter during a Transition.
    Returns:
      the callback used to find the epicenter of the Transition.

  - ### getEpicenter

    @Nullable public Rect getEpicenter()
    Returns the epicenter as specified by the `Transition.EpicenterCallback` or null if no callback exists.
    Returns:
      the epicenter as specified by the `Transition.EpicenterCallback` or null if no callback exists.
    See Also:
      - `setEpicenterCallback(EpicenterCallback)`

  - ### setPropagation

    public void setPropagation(@Nullable TransitionPropagation transitionPropagation)
    Sets the method for determining Animator start delays.

    When a Transition affects several Views like `Explode` or `Slide`, there may be a desire to have a "wave-front" effect such that the Animator start delay depends on position of the View. The TransitionPropagation specifies how the start delays are calculated.

    Parameters:
      `transitionPropagation` - The class used to determine the start delay of Animators created by this Transition. A null value indicates that no delay should be used.

  - ### getPropagation

    @Nullable public TransitionPropagation getPropagation()
    Returns the `TransitionPropagation` used to calculate Animator start delays.

    When a Transition affects several Views like `Explode` or `Slide`, there may be a desire to have a "wave-front" effect such that the Animator start delay depends on position of the View. The TransitionPropagation specifies how the start delays are calculated.

    Returns:
      the `TransitionPropagation` used to calculate Animator start delays. This is null by default.

  - ### getName

    @Nonnull public String getName()
    Returns the name of this Transition. This name is used internally to distinguish between different transitions to determine when interrupting transitions overlap. For example, a ChangeBounds running on the same target view as another ChangeBounds should determine whether the old transition is animating to different end values and should be canceled in favor of the new transition.

    By default, a Transition's name is simply the value of `Class.getName()`, but subclasses are free to override and return something different.

    Returns:
      The name of this transition.

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`

  - ### clone

    public Transition clone()
    Overrides:
      `clone` in class `Object`